/*******************************************************************************
 *
 * File Name: LDvector.cpp
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 1l3j 2-Sept-08
 *
 *******************************************************************************/

#include "LDvector.h"

#define DOUBLE_MIN_PRECISION 0.00001
bool compareDoubles(double a, double b)
{
	bool result;
	if((a < (b+DOUBLE_MIN_PRECISION)) && (a > (b-DOUBLE_MIN_PRECISION)))
	{
		result = true;
	}
	else
	{
		result = false;
	}

	return result;
}

bool compareVectors(vec * veca, vec * vecb)
{
	bool result = true;
	if(!compareDoubles(veca->x, vecb->x))
	{
		result = false;
	}
	if(!compareDoubles(veca->y, vecb->y))
	{
		result = false;
	}
	if(!compareDoubles(veca->z, vecb->z))
	{
		result = false;
	}
	return result;
}

bool compareMatricies(mat * mata, mat * matb)
{
	bool result = true;
	if(!compareVectors(&(mata->a), &(matb->a)))
	{
		result = false;
	}
	if(!compareVectors(&(mata->b), &(matb->b)))
	{
		result = false;
	}
	if(!compareVectors(&(mata->c), &(matb->c)))
	{
		result = false;
	}
	return result;
}

void copyVectors(vec * vecNew, vec * vecbToCopy)
{

	vecNew->x = vecbToCopy->x;
	vecNew->y = vecbToCopy->y;
	vecNew->z = vecbToCopy->z;
}

void copyMatricies(mat * matNew, mat * matToCopy)
{
	copyVectors(&(matNew->a), &(matToCopy->a));
	copyVectors(&(matNew->b), &(matToCopy->b));
	copyVectors(&(matNew->c), &(matToCopy->c));
}

/*
void multiplyMatricies(mat * matNew, mat * mat1, mat * mat2)
{
	matNew->a.x = (mat1->a.x * mat2->a.x) + (mat1->b.x * mat2->a.y) + (mat1->c.x * mat2->a.z);
	matNew->a.y = (mat1->a.y * mat2->a.x) + (mat1->b.y * mat2->a.y) + (mat1->c.y * mat2->a.z);
	matNew->a.z = (mat1->a.z * mat2->a.x) + (mat1->b.z * mat2->a.y) + (mat1->c.z * mat2->a.z);

	matNew->b.x = (mat1->a.x * mat2->b.x) + (mat1->b.x * mat2->b.y) + (mat1->c.x * mat2->b.z);
	matNew->b.y = (mat1->a.y * mat2->b.x) + (mat1->b.y * mat2->b.y) + (mat1->c.y * mat2->b.z);
	matNew->b.z = (mat1->a.z * mat2->b.x) + (mat1->b.z * mat2->b.y) + (mat1->c.z * mat2->b.z);
	
	matNew->c.x = (mat1->a.x * mat2->c.x) + (mat1->b.x * mat2->c.y) + (mat1->c.x * mat2->c.z);
	matNew->c.y = (mat1->a.y * mat2->c.x) + (mat1->b.y * mat2->c.y) + (mat1->c.y * mat2->c.z);
	matNew->c.z = (mat1->a.z * mat2->c.x) + (mat1->b.z * mat2->c.y) + (mat1->c.z * mat2->c.z);
	
}*/

void multiplyMatricies(mat * matNew, mat * mat1, mat * mat2)
{
	/*
	cout << "mat1: " << endl;
	cout << mat1->a.x << endl;
	cout << mat1->b.x << endl;
	cout << mat1->c.x << endl;
	cout << mat1->a.y << endl;
	cout << mat1->b.y << endl;
	cout << mat1->c.y << endl;
	cout << mat1->a.z << endl;
	cout << mat1->b.z << endl;
	cout << mat1->c.z << endl;

	cout << "mat2: " << endl;
	cout << mat2->a.x << endl;
	cout << mat2->b.x << endl;
	cout << mat2->c.x << endl;
	cout << mat2->a.y << endl;
	cout << mat2->b.y << endl;
	cout << mat2->c.y << endl;
	cout << mat2->a.z << endl;
	cout << mat2->b.z << endl;
	cout << mat2->c.z << endl;
	*/	
	
	matNew->a.x = mat1->a.x*mat2->a.x + mat1->b.x*mat2->a.y +  mat1->c.x*mat2->a.z;
	matNew->b.x = mat1->a.x*mat2->b.x + mat1->b.x*mat2->b.y +  mat1->c.x*mat2->b.z;
	matNew->c.x = mat1->a.x*mat2->c.x + mat1->b.x*mat2->c.y +  mat1->c.x*mat2->c.z;

	matNew->a.y = mat1->a.y*mat2->a.x + mat1->b.y*mat2->a.y +  mat1->c.y*mat2->a.z;
	matNew->b.y = mat1->a.y*mat2->b.x + mat1->b.y*mat2->b.y +  mat1->c.y*mat2->b.z;
	matNew->c.y = mat1->a.y*mat2->c.x + mat1->b.y*mat2->c.y +  mat1->c.y*mat2->c.z;

	matNew->a.z = mat1->a.z*mat2->a.x + mat1->b.z*mat2->a.y +  mat1->c.z*mat2->a.z;
	matNew->b.z = mat1->a.z*mat2->b.x + mat1->b.z*mat2->b.y +  mat1->c.z*mat2->b.z;
	matNew->c.z = mat1->a.z*mat2->c.x + mat1->b.z*mat2->c.y +  mat1->c.z*mat2->c.z;
}
	

void subtractVectors(vec * vecNew, vec * a, vec * b)
{

	vecNew->x = a->x - b->x;
	vecNew->y = a->y - b->y;
	vecNew->z = a->z - b->z;
}

void addVectors(vec * vecNew, vec * a, vec * b)
{

	vecNew->x = a->x + b->x;
	vecNew->y = a->y + b->y;
	vecNew->z = a->z + b->z;
}


void multiplyVectorByScalar(vec * vec, double scalar)
{
	vec->x = vec->x * scalar;
	vec->y = vec->y * scalar;
	vec->z = vec->z * scalar;
}


double calculateTheDistanceBetweenTwoPoints(vec * positionOfUnit1, vec * positionOfUnit2)
{
	return calculateTheDistanceBetweenTwoPoints(positionOfUnit1->x, positionOfUnit2->x, positionOfUnit1->y, positionOfUnit2->y, positionOfUnit1->z, positionOfUnit2->z);
}

double calculateTheDistanceBetweenTwoPoints(double positionXOfUnit1, double positionXOfUnit2, double positionYOfUnit1, double positionYOfUnit2, double positionZOfUnit1, double positionZOfUnit2)
{
	double xDistanceBetweenTheTwoUnits = fabs((positionXOfUnit1) - (positionXOfUnit2));
	double yDistanceBetweenTheTwoUnits = fabs((positionYOfUnit1) - (positionYOfUnit2));
	double zDistanceBetweenTheTwoUnits = fabs((positionZOfUnit1) - (positionZOfUnit2));
	double distanceBetweenTheTwoUnits = sqrt(pow(xDistanceBetweenTheTwoUnits, 2) + pow(yDistanceBetweenTheTwoUnits, 2) + pow(zDistanceBetweenTheTwoUnits, 2));

	return distanceBetweenTheTwoUnits;
}


















void createRotationxMatrix(mat* matrix, double rotation)
{
	matrix->b.y = cos(rotation);
	matrix->b.z = -sin(rotation);
	matrix->c.y = sin(rotation);
	matrix->c.z = cos(rotation);
}

void createRotationyMatrix(mat* matrix, double rotation)
{
	matrix->a.x = cos(rotation);
	matrix->a.z = sin(rotation);
	matrix->c.x = -sin(rotation);
	matrix->c.z = cos(rotation);
}

void createRotationzMatrix(mat* matrix, double rotation)
{
	matrix->a.x = cos(rotation);
	matrix->a.y = -sin(rotation);
	matrix->b.x = sin(rotation);
	matrix->b.y = cos(rotation);
}

double convertDegreesToRadian(double degrees)
{
	return (degrees/180*PI);
}

void createIdentityMatrix(mat* matrix)
{
	matrix->a.x = 1;
	matrix->b.x = 0;
	matrix->c.x = 0;
	matrix->a.y = 0;
	matrix->b.y = 1;
	matrix->c.y = 0;
	matrix->a.z = 0;
	matrix->b.z = 0;
	matrix->c.z = 1;
}

void copyMatrix2IntoMatrix1(mat* mat1, mat* mat2)
{
	mat1->a.x = mat2->a.x;
	mat1->b.x = mat2->b.x;
	mat1->c.x = mat2->c.x;
	mat1->a.y = mat2->a.y;
	mat1->b.y = mat2->b.y;
	mat1->c.y = mat2->c.y;
	mat1->a.z = mat2->a.z;
	mat1->b.z = mat2->b.z;
	mat1->c.z = mat2->c.z;
}


void scaleMatrix(mat * matrix, double scaleFactor)
{
	matrix->a.x = matrix->a.x * scaleFactor;
	matrix->b.y = matrix->b.y * scaleFactor;
	matrix->c.z = matrix->c.z * scaleFactor;
}


void createRotatationMatrix(mat * matrix, char rotationAxis, double rotationDegrees)
{
	if(rotationAxis == 'x')
	{
		createRotationxMatrix(matrix, rotationDegrees);
	}
	else if(rotationAxis == 'y')
	{
		createRotationyMatrix(matrix, rotationDegrees);
	}
	else if(rotationAxis == 'z')
	{
		createRotationzMatrix(matrix, rotationDegrees);
	}
}

