/*******************************************************************************
 *
 * File Name: LRRCsprite.cpp
 * Author: Richard Baxter
 * Project: Lego Rules CG Rounds Checker
 * Project Version: 1l3j 2-Sept-08
 * Project First Internal Release: 1aXx 18-Sept-05 (C)
 * Project Second Internal Release: 2aXx 02-April-06 (convert to C++)
 * Project Third Internal Release: 2b7d 26-Sept-06 (added sprites)
 * Project Fourth Internal Release: 2c4a 25-Feb-07 [rotation of models supported, copyCombatRelevantInheritedImmediateParentUnitDetailsIntoChildObject() no longer used]
 * Project Fifth Internal Release: 2d11a 3-June-07
 *
 *******************************************************************************/
/*This code allows the addition of a sprite into a given scene file where a sprite is a paragraph of text. [The text is to be rendered in 3D, and point towards the user POV - see CHECK THIS for missing code]*/


#include "LDglobalDefs.h"


#include "LRRCsprite.h"
#include "LDparser.h"
#include "math.h"
#include "LRRCcombat.h"
#include "LDreferenceManipulation.h"
#include "LDvector.h"
#include "LDvector.h"

#include "XMLrulesClass.h"

/*old;
#define SPRITE_EXTENSION ".ldr"
#define SPRITE_NAME_END (SPRITE_EXTENSION)
*/

#define CHAR_PLUS ('+')
#define CHAR_MINUS ('-')
#define CHAR_EQUALS ('=')

#define DEFAULT_LDRAW_SUBMODEL_COLOUR (16)


static string SPRITE_SUBMODEL_RANGE_FILE_NAME;
static int SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS;
static int SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS;
static int SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS;
static int SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_TRANS;
static int SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ;
static int SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ;
static int SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ;
static int SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_OPAQ;
static double SPRITE_SUBMODEL_RANGE_SCALE_FACTOR;

static int SPRITE_DEFAULT_COLOUR;

static double SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO;
static double SPRITE_TEXT_SCALE_FACTOR;
static double SPRITE_TEXT_DICE_SCALE_FACTOR;
static double SPRITE_CHAR_HEIGHT_IN_PIXELS;
static double SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT;

	static double SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_LINE_SPACING_RATIO;						//derivable
	static double SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable

static double SPRITE_CHAR_WIDTH_IN_PIXELS;
static double SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS;
static double SPRITE_DICE_WIDTH_IN_LDRAW_UNITS;
static double SPRITE_CHAR_SPACING_RATIO;

	static double SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS;		//derivable
	static double SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;	//derivable
	static double SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable

static double SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS;
static double SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS;

static double SPRITE_TEXT_DICE_Y_OFFSET;

static string SPRITE_NAME_START;
static string SPRITE_EXTENSION;
static string SPRITE_CHARACTER_START;
static string SPRITE_CHARACTER_EXTENSION;


void fillInLRRCSpriteExternVariables()
{
	RulesClass * currentReferenceRulesClass = LRRCrulesSprite;

	while(currentReferenceRulesClass->next != NULL)
	{
		if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_FILE_NAME_NAME)
		{
			SPRITE_SUBMODEL_RANGE_FILE_NAME = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS_NAME)
		{
			SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS_NAME)
		{
			SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS_NAME)
		{
			SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_TRANS_NAME)
		{
			SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_TRANS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ_NAME)
		{
			SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ_NAME)
		{
			SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ_NAME)
		{
			SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_OPAQ_NAME)
		{
			SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_OPAQ = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_SCALE_FACTOR_NAME)
		{
			SPRITE_SUBMODEL_RANGE_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_DEFAULT_COLOUR_NAME)
		{
			SPRITE_DEFAULT_COLOUR = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO_NAME)
		{
			SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXT_SCALE_FACTOR_NAME)
		{
			SPRITE_TEXT_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXT_DICE_SCALE_FACTOR_NAME)
		{
			SPRITE_TEXT_DICE_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHAR_HEIGHT_IN_PIXELS_NAME)
		{
			SPRITE_CHAR_HEIGHT_IN_PIXELS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT_NAME)
		{
			SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_CHAR_WIDTH_IN_PIXELS_NAME)
		{
			SPRITE_CHAR_WIDTH_IN_PIXELS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS_NAME)
		{
			SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS  = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_DICE_WIDTH_IN_LDRAW_UNITS_NAME)
		{
			SPRITE_DICE_WIDTH_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHAR_SPACING_RATIO_NAME)
		{
			SPRITE_CHAR_SPACING_RATIO = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS_NAME)
		{
			SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS_NAME)
		{
			SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}

		else if(currentReferenceRulesClass->name == SPRITE_TEXT_DICE_Y_OFFSET_NAME)
		{
			SPRITE_TEXT_DICE_Y_OFFSET = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_NAME_START_NAME)
		{
			SPRITE_NAME_START = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_EXTENSION_NAME)
		{
			SPRITE_EXTENSION = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHARACTER_START_NAME)
		{
			SPRITE_CHARACTER_START = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHARACTER_EXTENSION_NAME)
		{
			SPRITE_CHARACTER_EXTENSION = currentReferenceRulesClass->stringValue;
		}

		else
		{

		}


		currentReferenceRulesClass = currentReferenceRulesClass->next;
	}

	SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS = (SPRITE_CHAR_HEIGHT_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_LINE_SPACING_RATIO = (SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT * SPRITE_TEXT_SCALE_FACTOR);	//OLD: SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT/(SPRITE_TEXT_SCALE_FACTOR/4), //NB '/(SPRITE_TEXT_SCALE_FACTOR/4)' is due to dice size. without dice present SPRITE_LINE_SPACING_RATIO = (1.5);
	SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS*SPRITE_LINE_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);

	SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS = (SPRITE_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS = (SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);
	SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);
	SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_DICE_WIDTH_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_DICE_SCALE_FACTOR);

	/*
	cout << "SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS = " << SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_LINE_SPACING_RATIO = " << SPRITE_LINE_SPACING_RATIO << endl;
	cout << "SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS << endl;

	cout << "SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS = " << SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS = " << SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	*/




}
/*top level sprite routines - required for independent LRRCsprite.cpp calculations*/

	//NB this function does not add round's player's phase specific [movement/attack] sprites - these have to be added in LRRCmovement.cpp, and LRRCgame.cpp functions respectively
bool LRRCaddUnitDetailsSpritesToSceneFile(char* sceneFileName, char* sceneFileNameWithSprites, bool addTextualSpriteInfo, bool addRangeSpriteInfo, int currentPhase, int currentPlayerTurn)
{
	bool result = true;

	//declare initial scene references
	Reference * initialReferenceInSceneFile = new Reference();
	Reference * topLevelReferenceInSceneFile = new Reference(true);		//The model details information in this object is not required or meaningful, but needs to be passed into the parseFile/parseReferenceList recursive function

	//parse the scene files and build Reference linked lists
	if(!parseFile(sceneFileName, initialReferenceInSceneFile, topLevelReferenceInSceneFile))
	{//file does not exist
		cout << "The file: " << sceneFileName << " does not exist in the directory" << endl;
		return false;
	}
	//cout << "DEBUG: b1" << endl;

	int numSpritesAdded = 0;
	vec eyeCoords;
	eyeCoords.x = 0.0;
	eyeCoords.y = 0.0;
	eyeCoords.z = 0.0;

	Reference * spriteListInitialReference = new Reference();
	LRRCsearchSceneRefListAddUnitDetailsSpriteForSubmodels(initialReferenceInSceneFile, spriteListInitialReference, &eyeCoords, &numSpritesAdded, sceneFileNameWithSprites, initialReferenceInSceneFile, addTextualSpriteInfo, addRangeSpriteInfo, currentPhase, currentPlayerTurn);

	if(!addSpriteReferenceListToSceneFile(sceneFileName, sceneFileNameWithSprites, spriteListInitialReference, numSpritesAdded))
	{
		result = false;
	}

	delete initialReferenceInSceneFile;
	delete topLevelReferenceInSceneFile;
	delete spriteListInitialReference;
	
	return result;
}

bool LRRCaddUnitDetailsSpritesToScene(char* sceneFileName, char* sceneFileNameWithSprites, bool addTextualSpriteInfo, bool addRangeSpriteInfo, int currentPhase, int currentPlayerTurn, Reference * firstReferenceInScene)
{
	bool result = true;

	//declare initial scene references
	Reference * initialReferenceInSceneFile = firstReferenceInScene;

	int numSpritesAdded = 0;
	vec eyeCoords;
	eyeCoords.x = 0.0;
	eyeCoords.y = 0.0;
	eyeCoords.z = 0.0;

	Reference * spriteListInitialReference = new Reference();
	LRRCsearchSceneRefListAddUnitDetailsSpriteForSubmodels(initialReferenceInSceneFile, spriteListInitialReference, &eyeCoords, &numSpritesAdded, sceneFileNameWithSprites, initialReferenceInSceneFile, addTextualSpriteInfo, addRangeSpriteInfo, currentPhase, currentPlayerTurn);

	if(!addSpriteReferenceListToSceneFile(sceneFileName, sceneFileNameWithSprites, spriteListInitialReference, numSpritesAdded))
	{
		result = false;
	}

	delete spriteListInitialReference;
	
	return result;
}




//preconditions; assumes scene file has more than 1 person
void LRRCsearchSceneRefListAddUnitDetailsSpriteForSubmodels(Reference * referenceInSceneFile, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName, Reference * initialReferenceInSceneFile, bool addTextualSpriteInfo, bool addRangeSpriteInfo, int currentPhase, int currentPlayerTurn)
{
	//cout << "here03" << endl;

	Reference * unusedTargetReference;
	bool addTargetSpriteInfo = false;

	bool result = true;

	Reference * currentReference = referenceInSceneFile;

	while(currentReference->next != NULL)
	{
		if(currentReference->isSubModelReference)
		{
			performFinalUnitClassCalculations(currentReference->subModelDetails);

			/*a)  parse down the tree from the unit. NB this does not allow for copying of parent combat relevant items into child unit
				extract from performCloseCombatNormal*/

			//cout << "here031" << endl;

			//declare current submodel top level reference
			Reference * topLevelReferenceInCurrentSubmodel = new Reference(currentReference->name, currentReference->colour, true);
			//cout << "here0311" << endl;
				copyReferencePosition(topLevelReferenceInCurrentSubmodel, currentReference);
				copyAllUnitDetails(topLevelReferenceInCurrentSubmodel->subModelDetails, currentReference->subModelDetails);
				//cout << "here0312" << endl;
			searchSceneReferenceListAndDetermineTheDetailsOfAParticularUnitSubmodel(topLevelReferenceInCurrentSubmodel, currentReference->firstReferenceWithinSubModel, topLevelReferenceInCurrentSubmodel, true);
				//cout << "here0313" << endl;
			determineUnitTypeAndMinSpeedOfUnitGroup(topLevelReferenceInCurrentSubmodel->subModelDetails);
				//cout << "here0314" << endl;
			performFinalUnitClassCalculations(topLevelReferenceInCurrentSubmodel->subModelDetails);


			//cout << "topLevelReferenceInCurrentSubmodel->colour = " << topLevelReferenceInCurrentSubmodel->colour << endl;
			//cout << "here032" << endl;

			/*recursive parsing enabled*/
			if(topLevelReferenceInCurrentSubmodel->subModelDetails->numPerson > 1)
			{
				//cout << "DEBUG 1c" << endl;
				LRRCsearchSceneRefListAddUnitDetailsSpriteForSubmodels(currentReference->firstReferenceWithinSubModel, spriteListInitialReference, eyeCoords, numSpritesAdded, sceneFileName, initialReferenceInSceneFile, addTextualSpriteInfo, addRangeSpriteInfo, currentPhase, currentPlayerTurn);
				//cout << "DEBUG 1d" << endl;
			}

			//cout << "here033" << endl;

			//cout << "DEBUG topLevelReferenceInCurrentSubmodel->subModelDetails->unitType = " << topLevelReferenceInCurrentSubmodel->subModelDetails->unitType << endl;
			//cout << "DEBUG topLevelReferenceInCurrentSubmodel->subModelDetails->numPerson  = " << topLevelReferenceInCurrentSubmodel->subModelDetails->numPerson  << endl;

			/*
			OLD;
				only adds sprites to units with either an attack and defence value, a defence and movement value; therefore sprites are not currently added for stationary catapults
				if(((topLevelReferenceInCurrentSubmodel->subModelDetails->defenceTotal > 0) && (topLevelReferenceInCurrentSubmodel->subModelDetails->closeCombatAttackTotal > 0)) || ((topLevelReferenceInCurrentSubmodel->subModelDetails->defenceTotal > 0) && (topLevelReferenceInCurrentSubmodel->subModelDetails->movementSpeed > 0)))
				NB assumes horses do not have a defence value
			*/

			if((topLevelReferenceInCurrentSubmodel->subModelDetails->numPerson == 1) || ((topLevelReferenceInCurrentSubmodel->subModelDetails->unitType > UNIT_TYPE_HORSE_AND_SADDLE) && (topLevelReferenceInCurrentSubmodel->subModelDetails->numPerson > 0)))
			{
				//cout << "here033" << endl;
				if(!LRRCdetermineSpriteInfoAndAddSpriteToSpriteRefList(topLevelReferenceInCurrentSubmodel, unusedTargetReference, spriteListInitialReference, eyeCoords, numSpritesAdded, sceneFileName, addTextualSpriteInfo, addRangeSpriteInfo, addTargetSpriteInfo, currentPhase, currentPlayerTurn))
				{
					result = false;
				}
			}
			
			delete topLevelReferenceInCurrentSubmodel;
		}

		currentReference = currentReference->next;
	}
}














































/*medium level sprite routines - these can be used by LRRCsprite.cpp top level routines or by LRRCgame.cpp routines*/

bool LRRCdetermineSpriteInfoAndAddSpriteToSpriteRefList(Reference * unitReference, Reference * targetReference, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName, bool addTextualSpriteInfo, bool addRangeSpriteInfo, bool addTargetSpriteInfo, int currentPhase, int currentPlayerTurn)
{
	bool result = true;

	//cout << "here0" << endl;

	/*
	cout << "bb1" << endl;
	cout << "(unitReference->name) = " << (unitReference->name) << endl;
	//cout << "spriteReferenceFileName = " << spriteReferenceFileName << endl;
	//cout << "spriteListInitialReference->name = " << spriteListInitialReference->name << endl;
	cout << "(unitReference->absolutePosition.x) = " << (unitReference->absolutePosition.x) << endl;
	cout << "bb2" << endl;
	*/




	//increment numSpritesAdded
#ifdef DEBUG_ADD_INDIVIDUAL_SPRITES
	*numSpritesAdded = (*numSpritesAdded + 1);
#endif


	//cout << "here1" << endl;

	int * numSpritesAddedLocal;
	Reference * spriteSubmodelCurrentReference;
#ifdef DEBUG_ADD_INDIVIDUAL_SPRITES
	//add sprite info [textual + range info] to reference list:
	Reference * spriteSubmodelInitialReference = new Reference();
	spriteSubmodelCurrentReference = spriteSubmodelInitialReference;
	int numSpritesAddedLocalUnused = 0;
	numSpritesAddedLocal = &numSpritesAddedLocalUnused;
#else
	numSpritesAddedLocal = numSpritesAdded;
	spriteSubmodelCurrentReference = search1DRefListFindLastReference(spriteListInitialReference);
#endif

	//cout << "spriteSubmodelCurrentReference->deformationMatrix->a.x = " << (&((&(spriteSubmodelCurrentReference->deformationMatrix))->a))->x << endl;


	if(addTextualSpriteInfo)	//always if addTextualSpriteInfo is true
	{
		//cout << "here11" << endl;
		//create textual sprite info:
		string * spriteTextString = new string();
		//char * spriteTextString = new char[100000];

		int spriteNumberOfLines;
		spriteNumberOfLines = SPRITE_TEXTUAL_NUM_OF_LINES;
		int * spriteColourArray = new int[spriteNumberOfLines];
		LRRCgenerateTextualSpriteInfoString(unitReference, spriteTextString, spriteColourArray);
		spriteSubmodelCurrentReference = LRRCaddTextualSpriteInfoStringToReferenceList(unitReference, spriteTextString, spriteColourArray, spriteSubmodelCurrentReference, spriteNumberOfLines, numSpritesAddedLocal);
		
		delete spriteTextString;
		delete spriteColourArray;
	}

	//cout << "here1b" << endl;

	if((addRangeSpriteInfo) && ((obtainReferencePlayerID(unitReference) == currentPlayerTurn) || (currentPhase == GAME_PHASE_GENERIC)))
	{
		//cout << "here1b1" << endl;

		//cout << "obtainReferencePlayerID(unitReference) = " << obtainReferencePlayerID(unitReference) << endl;
		//cout << "currentPlayerTurn = " << currentPlayerTurn << endl;
		//cout << "here12" << endl;
		spriteSubmodelCurrentReference = LRRCaddRangeSpriteInfoToReferenceList(spriteSubmodelCurrentReference, unitReference, currentPhase, numSpritesAddedLocal);
	}

	//cout << "here1c" << endl;

	if(addTargetSpriteInfo)
	{
		//cout << "here13" << endl;
		spriteSubmodelCurrentReference = LRRCaddTargetSpriteInfoToReferenceList(spriteSubmodelCurrentReference, unitReference, targetReference, currentPhase, numSpritesAddedLocal);
	}





#ifdef DEBUG_ADD_INDIVIDUAL_SPRITES

	//cout << "here2" << endl;

	//generate sprite reference name
	char * spriteReferenceFileName = new char[DAT_FILE_REF_SUBMODEL_NAME_LENGTH_MAX];



	//cout << "here2a" << endl;
	LRRCcreateSpriteReferenceName(spriteReferenceFileName, *numSpritesAdded, sceneFileName);
	#ifdef DEBUG_SPRITES
	cout << "spriteReferenceFileName = " << spriteReferenceFileName << endl;
	#endif

	//cout << "DEBUG unitBeingSprited = " << unitReference->name << endl;

	//cout << "here3" << endl;

	#ifdef CPLUSPLUSERRORCORRECTION3
		char * CHICKENDEBUG = new char[DAT_FILE_REF_MAX_SIZE*DAT_FILE_MAX_NUM_OF_REFERENCES];
	#endif


	//writeReferencesToFile
	if(!writeReferencesToFile(spriteReferenceFileName, spriteSubmodelInitialReference))
	{
		result = false;
	}

	delete spriteSubmodelInitialReference;
	
	int spriteDefaultColour = SPRITE_DEFAULT_COLOUR; //unitReference->colour doesnt work,, //CHECK THIS - this should be the player ID of the player who owns the the unit, unitDetails

	//cout << "here4" << endl;

	//addSpriteReferenceToSpriteListByteArray
	if(!LRRCaddSpriteToSpriteReferenceList(&(unitReference->absolutePosition), eyeCoords, spriteListInitialReference, spriteReferenceFileName, spriteDefaultColour))
	{
		result = false;
	}


	//cout << "here5" << endl;

	delete spriteReferenceFileName;
	//cout << "DEBUG 1m" << endl;
#endif




	return result;
}


//currently this function just adds a plain line between the unit and the target, in the future it could be more complex
Reference * LRRCaddTargetSpriteInfoToReferenceList(Reference * spriteSubmodelInitialReference, Reference * unitReference, Reference * targetReference, int currentPhase, int * numSpritesAdded)
{
	bool result = true;
	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	//add movement/longdistance/closecombat target line [red/orange/green line]
	spriteSubmodelCurrentReference->type = REFERENCE_TYPE_LINE;
	if(currentPhase == GAME_PHASE_MOVEMENT)
	{
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ;
	}
	else if(currentPhase == GAME_PHASE_LONGDISTANCECOMBAT)
	{
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ;
	}
	else if(currentPhase == GAME_PHASE_CLOSECOMBAT)
	{
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ;
	}
	else if(currentPhase == GAME_PHASE_AIONLY_TARGET_SELECTION)
	{
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_TARGET_SELECTION_COLOUR_OPAQ;
	}
	else
	{
		result = false;
		cout << "error: LRRCaddTargetSpriteInfoToReferenceList() illegal phase " << endl;
	}

	#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
	copyVectors(&(spriteSubmodelCurrentReference->vertex1relativePosition), &(unitReference->absolutePosition));
	copyVectors(&(spriteSubmodelCurrentReference->vertex2relativePosition), &(targetReference->absolutePosition));
	#else
	vec localvec;
	subtractVectors(&localvec, &(unitReference->absolutePosition), &(unitReference->absolutePosition));
	copyVectors(&(spriteSubmodelCurrentReference->vertex1relativePosition), &localvec);
	subtractVectors(&localvec, &(targetReference->absolutePosition), &(unitReference->absolutePosition));
	copyVectors(&(spriteSubmodelCurrentReference->vertex2relativePosition), &localvec);
	#endif

	Reference * newReference1 = new Reference();
	spriteSubmodelCurrentReference -> next = newReference1;
	spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;

	*numSpritesAdded = *numSpritesAdded + 1;

	return spriteSubmodelCurrentReference;
}

Reference * LRRCaddRangeSpriteInfoToReferenceList(Reference * spriteSubmodelInitialReference, Reference * unitReference, int currentPhase, int * numSpritesAdded)
{
	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	mat currentDeformationMatrix;

	ModelDetails * unitDetails = unitReference->subModelDetails;

	//cout << "currentPhase = " << GAME_PHASE_GENERIC << endl;

	if((currentPhase == GAME_PHASE_MOVEMENT) || (currentPhase == GAME_PHASE_GENERIC))
	{
		//add movement range info [green ring/sphere/cylinder]
		//cout << "(unitDetails->movementSpeed)" << (unitDetails->movementSpeed) << endl;
		//cout << "vv1" << endl;
		createIdentityMatrix(&currentDeformationMatrix);
		scaleMatrix(&currentDeformationMatrix, ((unitDetails->movementSpeed)*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));
		//cout << "vv1a" << endl;
		//cout << "spriteSubmodelCurrentReference->deformationMatrix->a.x = " << (&((&(spriteSubmodelCurrentReference->deformationMatrix))->a))->x << endl;

		copyMatrix2IntoMatrix1(&(spriteSubmodelCurrentReference->deformationMatrix), &(currentDeformationMatrix));
		//cout << "vv1b" << endl;
		spriteSubmodelCurrentReference->type = REFERENCE_TYPE_SUBMODEL;
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ;
		spriteSubmodelCurrentReference->name = SPRITE_SUBMODEL_RANGE_FILE_NAME;
		#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
		addVectors(&(spriteSubmodelCurrentReference->relativePosition), &(spriteSubmodelCurrentReference->relativePosition), &(unitReference->absolutePosition));
		#endif
		//cout << "vv1c" << endl;
		Reference * newReference1 = new Reference();
		spriteSubmodelCurrentReference -> next = newReference1;
		//cout << "vv1d" << endl;
		spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;

		*numSpritesAdded = *numSpritesAdded + 1;

	}
	if((currentPhase == GAME_PHASE_LONGDISTANCECOMBAT) || (currentPhase == GAME_PHASE_GENERIC))
	{
		//add long distance combat range info [orange ring/sphere/cylinder]
		//cout << "vv2" << endl;
		createIdentityMatrix(&currentDeformationMatrix);
		scaleMatrix(&currentDeformationMatrix, ((unitDetails->longDistanceAttackBaseRange)*SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM));
		copyMatrix2IntoMatrix1(&(spriteSubmodelCurrentReference->deformationMatrix), &(currentDeformationMatrix));
		spriteSubmodelCurrentReference->type = REFERENCE_TYPE_SUBMODEL;
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ;
		spriteSubmodelCurrentReference->name = SPRITE_SUBMODEL_RANGE_FILE_NAME;
		#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
		addVectors(&(spriteSubmodelCurrentReference->relativePosition), &(spriteSubmodelCurrentReference->relativePosition), &(unitReference->absolutePosition));
		#endif
		Reference * newReference2 = new Reference();
		spriteSubmodelCurrentReference -> next = newReference2;
		spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;

		*numSpritesAdded = *numSpritesAdded + 1;
	}
	if((currentPhase == GAME_PHASE_CLOSECOMBAT) || (currentPhase == GAME_PHASE_GENERIC))
	{
		//add close combat range info [red ring/sphere/cylinder - only a few units in diameter - ie quite small]
		//cout << "vv3" << endl;
		createIdentityMatrix(&currentDeformationMatrix);
		scaleMatrix(&currentDeformationMatrix, (CLOSE_AND_LONGDISTANCE_COMBAT_BOUNDARY*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));
		copyMatrix2IntoMatrix1(&(spriteSubmodelCurrentReference->deformationMatrix), &(currentDeformationMatrix));
		spriteSubmodelCurrentReference->type = REFERENCE_TYPE_SUBMODEL;
		spriteSubmodelCurrentReference->colour = SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ;
		spriteSubmodelCurrentReference->name = SPRITE_SUBMODEL_RANGE_FILE_NAME;
		#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
		addVectors(&(spriteSubmodelCurrentReference->relativePosition), &(spriteSubmodelCurrentReference->relativePosition), &(unitReference->absolutePosition));
		#endif
		Reference * newReference3 = new Reference();
		spriteSubmodelCurrentReference -> next = newReference3;
		spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;

		*numSpritesAdded = *numSpritesAdded + 1;
	}

	return spriteSubmodelCurrentReference;
}

void LRRCcreateSpriteReferenceName(char * spriteReferenceFileName, int spriteIndex, char * sceneFileName)
{
	//cout << "66" << endl;
	//creates sprite reference name spriteReferenceName = [SPRITE_NAME_START][spriteIndex][sceneFileName]
	char * tempString = new char[SPRITE_INDEX_MAGNITUDE*CPLUSPLUSERRORCORRECTION2];

	spriteReferenceFileName[0] = '\0';

	strcpy(tempString, sceneFileName);

	int i;
	for(i = 0; i < strlen(tempString); i++)
	{
		if(tempString[i] == '.')
		{
			tempString[i] = '\0';
		}
	}
	strcat(spriteReferenceFileName, tempString);

	strcat(spriteReferenceFileName, SPRITE_NAME_START.c_str());
	//itoa(spriteIndex, tempString, 10);
	sprintf(tempString, "%d", spriteIndex);

	strcat(spriteReferenceFileName, tempString);

	strcat(spriteReferenceFileName, SPRITE_EXTENSION.c_str());

	//cout << "67" << endl;
	delete tempString;
	//cout << "68" << endl;
	//create the "spritex.ldr" file that will be referenced by the scene file
}


//CHECK THIS spriteSubmodelCurrentReference parameter may have to be changed to the LRRCaddTextualSpriteInfoStringToReferenceList() function return value
//bool LRRCaddTextualSpriteInfoStringToReferenceList(string * spriteTextString, int spriteColourArray[], Reference * spriteSubmodelFirstReference, int spriteNumberOfLines, Reference * spriteSubmodelFinalReference);
Reference * LRRCaddTextualSpriteInfoStringToReferenceList(Reference * unitReference, string * spriteTextString, int spriteColourArray[], Reference * spriteSubmodelInitialReference, int spriteNumberOfLines, int * numSpritesAdded)
{
	bool result = true;

	char * spriteText = new char[(*spriteTextString).size()+1];
	const char * constSpriteText = (*spriteTextString).c_str();
	strcpy(spriteText, constSpriteText);
	int spriteTextLength = (int)strlen(spriteText);

	int spriteTextIndex;

	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	vec spriteSubmodelCurrentReferencePosition;
	spriteSubmodelCurrentReferencePosition.x = 0.0 - (SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS / 2);
	spriteSubmodelCurrentReferencePosition.y = 0.0 + SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS;
	spriteSubmodelCurrentReferencePosition.z = 0.0;


	//common local variables for loop
	double spriteCurrentCharacterSpacing;
	int spriteLineNumber = 0;

	for(spriteTextIndex = 0; spriteTextIndex < spriteTextLength; spriteTextIndex++)
	{
		/*convert lowercase text to uppercase text:*/
		if((spriteText[spriteTextIndex] >= 'a') && (spriteText[spriteTextIndex] <= 'z'))
		{
			spriteText[spriteTextIndex] = spriteText[spriteTextIndex] - ANSI_DECIMAL_DIFF_BETWEEN_CASE_TEXT;
		}

		if(spriteText[spriteTextIndex] == '\n')
		{
			spriteLineNumber++;
			if(spriteLineNumber >= spriteNumberOfLines)
			{
				cout << "error; (spriteLineNumber >= spriteNumberOfLines)" << endl;
				result = false;
			}
			spriteSubmodelCurrentReferencePosition.y  = spriteSubmodelCurrentReferencePosition.y + SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = 0.0 - (SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS / 2);
		}
		else if(((spriteText[spriteTextIndex] >= '0') && (spriteText[spriteTextIndex] <= '9')) || (spriteText[spriteTextIndex] == CHAR_PLUS) || (spriteText[spriteTextIndex] == CHAR_MINUS) || (spriteText[spriteTextIndex] == CHAR_EQUALS))
		{
			spriteCurrentCharacterSpacing = SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS; 	//OLD; SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS * (SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS/SPRITE_CHAR_WIDTH_IN_PIXELS);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;

			#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
			vec tempAbsPos;
			addVectors(&tempAbsPos, &spriteSubmodelCurrentReferencePosition, &(unitReference->absolutePosition));
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &tempAbsPos, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#else
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#endif
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing;
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
			*numSpritesAdded = *numSpritesAdded + 1;
		}
		else if((spriteText[spriteTextIndex] >= 'A') && (spriteText[spriteTextIndex] <= 'Z'))
		{
			spriteCurrentCharacterSpacing = SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
			vec tempAbsPos;
			addVectors(&tempAbsPos, &spriteSubmodelCurrentReferencePosition, &(unitReference->absolutePosition));
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &tempAbsPos, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#else
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#endif
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
			*numSpritesAdded = *numSpritesAdded + 1;
		}
		else if(((unsigned char)spriteText[spriteTextIndex] > (unsigned char)SPRITE_CHARACTER_DICE_OFFSET) && ((unsigned char)spriteText[spriteTextIndex] <= (unsigned char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL)))
		{
			spriteCurrentCharacterSpacing = SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing;
			#ifndef DEBUG_ADD_INDIVIDUAL_SPRITES
			vec tempAbsPos;
			addVectors(&tempAbsPos, &spriteSubmodelCurrentReferencePosition, &(unitReference->absolutePosition));
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &tempAbsPos, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#else
			LRRCspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			#endif
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
			*numSpritesAdded = *numSpritesAdded + 1;
		}
		else if(spriteText[spriteTextIndex] == ' ')
		{
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + (SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS/2);
		}
		else
		{
			char temp = (char)SPRITE_CHARACTER_DICE_OFFSET;
			char temp2 = (char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL);
			printf("\nunknown character - system must exit (character = %c %d)", spriteText[spriteTextIndex], spriteText[spriteTextIndex]);
			printf("\nNB SPRITE_CHARACTER_DICE_OFFSET = %c %d", temp, temp);
			printf("\nNB (SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL) = %c %d", temp2, temp2);
			exit(0);
		}
	}

	delete spriteText;



	//spriteSubmodelFinalReference = spriteSubmodelCurrentReference;

	return spriteSubmodelCurrentReference;
}




/*primary sprite routines*/

//OLD: new items [eg char, Reference] are currently not being properly created in LRRCsprite.cpp
bool LRRCaddSpriteToSpriteReferenceList(vec * spriteSceneCoords, vec * eyeCoords, Reference * spriteListInitialReference, char * spriteReferenceFileName, int spriteDefaultColour)
{
	//add sprite to spriteByteArray (replace sprite of sprite index, spriteIndex, if it already exists)

	bool result = true;

	//spriteReferenceSubmodelNameLength = (int)strlen(spriteReferenceFileName);

	Reference * spriteReference = new Reference();

	spriteReference->colour = spriteDefaultColour;		//CHECK THIS - this should be changed to player
	spriteReference->type = REFERENCE_TYPE_SUBMODEL;
	mat spriteRotationMatrix;

	createIdentityMatrix(&spriteRotationMatrix);
/*original before RBB 26-jan-07
	LRRCgenerateSpriteRotationMatrix(spriteSceneCoords, eyeCoords, &spriteRotationMatrix);
*/
	copyMatrix2IntoMatrix1(&(spriteReference->deformationMatrix), &(spriteRotationMatrix));
		//spriteReference->deformationMatrix = spriteRotationMatrix;

	spriteReference->relativePosition.x = spriteSceneCoords->x;
	spriteReference->relativePosition.y = spriteSceneCoords->y;
	spriteReference->relativePosition.z = spriteSceneCoords->z;
	spriteReference->name = spriteReferenceFileName;


	int lineNumberInFileOfSprite;

	/*
	cout << "about to findTextInByteArray;" << endl;
	cout << "DEBUG: spriteListByteArray = " << spriteListByteArray << endl;
	cout << "DEBUG: *spriteListByteArraySize = " << *spriteListByteArraySize << endl;
	cout << "DEBUG: spriteReferenceString = " << spriteReferenceString << endl;
	cout << "DEBUG: spriteReferenceStringSize = " << spriteReferenceStringSize << endl;
	cout << "DEBUG: &lineNumberInFileOfSprite = " << &lineNumberInFileOfSprite << endl;
	*/

	if(search1DRefListNameAndColourFindRef(spriteListInitialReference, spriteReference))
	{
		//cout << "DEBUG LRRCsprite.cpp 3b " << endl;

		if(!search1DRefListNameAndColourReplaceRef(spriteListInitialReference, spriteReference, spriteReference))
		{
			cout << "error: cannot replace Reference in Sprite Reference List" << endl;
			cout << "\t spriteReference->colour  = \n" << spriteReference->colour  << endl;
			cout << "\t spriteReference->name = " << spriteReference->name << endl;
			result = false;
		}
	}
	else
	{
		//cout << "DEBUG LRRCsprite.cpp 3c " << endl;
		if(!search1DRefListAddReference(spriteListInitialReference, spriteReference))
		{
			cout << "error: cannot add Reference to Sprite Reference List" << endl;
			cout << "\t spriteReference->colour  = \n" << spriteReference->colour  << endl;
			cout << "\t spriteReference->name = " << spriteReference->name << endl;
			result = false;
		}
	}

	delete spriteReference;
	
	//cout << "DEBUG LRRCsprite.cpp 4 " << endl;

	return result;
}

void LRRCgenerateTextualSpriteInfoString(Reference * unitReferenceInSceneFile, string * spriteTextString, int spriteColourArray[])
{
	ModelDetails * unitDetailsInSceneFile = unitReferenceInSceneFile->subModelDetails;

	/*Start Sprite Text Creation*/
#ifdef SPRITE_TEXTUAL_INCLUDE_ALL_COMBAT_INFO
	spriteColourArray[0] = DAT_FILE_COLOUR_WHITE;
	spriteColourArray[1] = DAT_FILE_COLOUR_WHITE;
	spriteColourArray[2] = DAT_FILE_COLOUR_BLUE;
	spriteColourArray[3] = DAT_FILE_COLOUR_YELLOW;
	spriteColourArray[4] = DAT_FILE_COLOUR_RED;
	spriteColourArray[5] = DAT_FILE_COLOUR_MAGENTA;
	spriteColourArray[6] = DAT_FILE_COLOUR_MAGENTA;
	//spriteColourArray[4] = DAT_FILE_COLOUR_CYAN;
	//spriteColourArray[5] = DAT_FILE_COLOUR_MAGENTA;
	//spriteColourArray[6] = DAT_FILE_COLOUR_BLACK;
	//spriteColourArray[5] = DAT_FILE_COLOUR_DARKGREY;
#else
	spriteColourArray[0] = DAT_FILE_COLOUR_WHITE;
	spriteColourArray[1] = DAT_FILE_COLOUR_WHITE;
	spriteColourArray[2] = DAT_FILE_COLOUR_BLUE;
	spriteColourArray[3] = DAT_FILE_COLOUR_RED;
	spriteColourArray[4] = DAT_FILE_COLOUR_MAGENTA;
	spriteColourArray[5] = DAT_FILE_COLOUR_MAGENTA;
	spriteColourArray[6] = DAT_FILE_COLOUR_MAGENTA;
#endif

	char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH*CPLUSPLUSERRORCORRECTION1];		//for some reason tempString must be very large or else the heap will get corrupted
	//char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH];

	//ii)  perform sprite calculations
	//cout << "DEBUG 1g" << endl;
	int baseDefenceLevel = invertLevel(unitDetailsInSceneFile->armourDefenceValue);
	int baseCloseCombatAttackLevel = invertLevel(unitDetailsInSceneFile->closeCombatAttackValue);
	int baseLongDistanceAttackLevel = invertLevel(unitDetailsInSceneFile->longDistanceAttackValue);

	//cout << "DEBUG: movementSpeed = " << movementSpeed << endl;

	//ii)
	//cout << "DEBUG 1h" << endl;

	//cout << "DEBUG baseDefenceLevel = " << baseDefenceLevel << endl;
	//cout << "DEBUG unitDetailsInSceneFile->defenceBonus = " << unitDetailsInSceneFile->defenceBonus << endl;
	//cout << "DEBUG unitDetailsInSceneFile->defenceTotal = " << unitDetailsInSceneFile->defenceTotal << endl;


	/*Unit Name Information*/

#ifdef SPRITE_TEXTUAL_INCLUDE_NAME_INFO
	int iTemp = 0;
	char cTemp =  unitReferenceInSceneFile->name[iTemp];
	bool fullstopFound = false;
	while((cTemp != '\0') && (!fullstopFound))
	{
		cTemp = unitReferenceInSceneFile->name[iTemp];
		if(cTemp == '.')
		{
			fullstopFound = true;
			tempString[iTemp] = '\0';
		}
		else
		{
			tempString[iTemp] = cTemp;
		}
		iTemp++;
	}
	*spriteTextString = *spriteTextString + tempString;
	//cout << "*spriteTextString=" << *spriteTextString << endl;
#endif

	/*Player ID Information*/
*spriteTextString = *spriteTextString + '\n';
#ifdef SPRITE_TEXTUAL_INCLUDE_PLAYERID_INFO
	tempString[0] = '\0';

	//itoa(obtainReferencePlayerID(unitReferenceInSceneFile), tempString, 10);
	sprintf(tempString, "%d", obtainReferencePlayerID(unitReferenceInSceneFile));

	*spriteTextString = *spriteTextString + "ID = " + tempString;
	//cout << "*spriteTextString=" << *spriteTextString << endl;
#endif


	/*Defence Related Sprite Information*/
*spriteTextString = *spriteTextString + '\n';
#ifdef SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
	#ifdef SPRITE_TEXTUAL_INCLUDE_ALL_COMBAT_INFO
		*spriteTextString = *spriteTextString + "     D = ";
	#else
		*spriteTextString = *spriteTextString + "D = ";
	#endif
#endif
	if(unitDetailsInSceneFile->defenceTotal > 0)
	{
	#ifdef SPRITE_ALWAYS_ADD_TEXT
		tempString[0] = '\0';
		//itoa(baseDefenceLevel, tempString, 10);
		*spriteTextString = *spriteTextString + tempString;
		if(unitDetailsInSceneFile->defenceBonus > 0)
		{
			tempString[0] = '\0';
			//itoa(unitDetailsInSceneFile->defenceBonus, tempString, 10);
			sprintf(tempString, "%d", unitDetailsInSceneFile->defenceBonus);
			*spriteTextString = *spriteTextString + " - " + tempString;
		}
	#endif
	#ifdef SPRITES_DISPLAY_DICE
		if((unitDetailsInSceneFile->defenceTotal >= MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED) && (unitDetailsInSceneFile->defenceTotal <= MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED))
		{
			tempString[0] = (unitDetailsInSceneFile->defenceTotal + SPRITE_CHARACTER_DICE_OFFSET);
			tempString[1] = '\0';
			*spriteTextString = *spriteTextString + tempString;
		}
		else
		{
	#ifndef SPRITE_ALWAYS_ADD_TEXT
			tempString[0] = '\0';
			//itoa(((unitDetailsInSceneFile->defenceTotal)*2), tempString, 10);
			sprintf(tempString, "%d", (unitDetailsInSceneFile->defenceTotal)*2);
			*spriteTextString = *spriteTextString + tempString;
	#endif
		}
	#endif
	}
	else
	{
		tempString[0] = '-';
		tempString[1] = '\0';
		*spriteTextString = *spriteTextString + tempString;
	}
	//cout << "*spriteTextString=" << *spriteTextString << endl;

	//cout << "DEBUG 1i" << endl;

#ifdef SPRITE_TEXTUAL_INCLUDE_ALL_COMBAT_INFO

		/*Long Distance Attack Related Sprite Information*/
	*spriteTextString = *spriteTextString + '\n';
	#ifdef SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
		*spriteTextString = *spriteTextString + "ALD = ";
	#endif
		//cout << "DEBUG 1i0" << endl;
		if(unitDetailsInSceneFile->longDistanceAttackTotal > 0)
		{
			//cout << "DEBUG 1i1" << endl;
		#ifdef SPRITE_ALWAYS_ADD_TEXT
			tempString[0] = '\0';
			//itoa(baseLongDistanceAttackLevel, tempString, 10);
			sprintf(tempString, "%d", baseLongDistanceAttackLevel);
			*spriteTextString = *spriteTextString + tempString;
			if(unitDetailsInSceneFile->longDistanceAttackBonus > 0)
			{
				tempString[0] = '\0';
				//itoa(unitDetailsInSceneFile->longDistanceAttackBonus, tempString, 10);
				sprintf(tempString, "%d", unitDetailsInSceneFile->longDistanceAttackBonus);
				*spriteTextString = *spriteTextString + " - " + tempString;
			}
		#endif
		#ifdef SPRITES_DISPLAY_DICE
			if((unitDetailsInSceneFile->longDistanceAttackTotal >= MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED) && (unitDetailsInSceneFile->longDistanceAttackTotal <= MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED))
			{
				//cout << "DEBUG 1i2" << endl;
				tempString[0] = (unitDetailsInSceneFile->longDistanceAttackTotal + SPRITE_CHARACTER_DICE_OFFSET);
				tempString[1] = '\0';
				//cout << "DEBUG 1i3" << endl;
				*spriteTextString = *spriteTextString + tempString;
			}
			else
			{
			#ifndef SPRITE_ALWAYS_ADD_TEXT
					tempString[0] = '\0';
					//itoa(((unitDetailsInSceneFile->longDistanceAttackTotal)*2), tempString, 10);
					sprintf(tempString, "%d", (unitDetailsInSceneFile->longDistanceAttackTotal)*2);
					*spriteTextString = *spriteTextString + tempString;
			#endif
			}
		#endif
		}
		else
		{
			//cout << "DEBUG 1i6" << endl;
			tempString[0] = '-';
			tempString[1] = '\0';
			*spriteTextString = *spriteTextString + tempString;
		}
		//cout << "*spriteTextString=" << *spriteTextString << endl;

		//cout << "DEBUG 1j" << endl;

		/*Close Combat Attack Related Sprite Information*/
	*spriteTextString = *spriteTextString + '\n';
	#ifdef SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
		*spriteTextString = *spriteTextString + "ACC = ";
	#endif
		if(unitDetailsInSceneFile->closeCombatAttackTotal > 0)
		{
		#ifdef SPRITE_ALWAYS_ADD_TEXT
			tempString[0] = '\0';
			//itoa(baseCloseCombatAttackLevel, tempString, 10);
			sprintf(tempString, "%d", baseCloseCombatAttackLevel);
			*spriteTextString = *spriteTextString + tempString;
			if(unitDetailsInSceneFile->closeCombatAttackBonus > 0)
			{
				tempString[0] = '\0';
				//itoa(unitDetailsInSceneFile->closeCombatAttackBonus, tempString, 10);
				sprintf(tempString, "%d", unitDetailsInSceneFile->closeCombatAttackBonus);
				*spriteTextString = *spriteTextString + " + " + tempString;
			}
		#endif
		#ifdef SPRITES_DISPLAY_DICE
			if((unitDetailsInSceneFile->closeCombatAttackTotal >= MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED) && (unitDetailsInSceneFile->closeCombatAttackTotal <= MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED))
			{
				tempString[0] = (unitDetailsInSceneFile->closeCombatAttackTotal + SPRITE_CHARACTER_DICE_OFFSET);
				tempString[1] = '\0';
				*spriteTextString = *spriteTextString + tempString;
			}
			else
			{
		#ifndef SPRITE_ALWAYS_ADD_TEXT
			tempString[0] = '\0';
			//itoa(((unitDetailsInSceneFile->closeCombatAttackTotal)*2), tempString, 10);
			sprintf(tempString, "%d", (unitDetailsInSceneFile->closeCombatAttackTotal)*2);
			*spriteTextString = *spriteTextString + tempString;
		#endif
			}
		#endif
		}
		else
		{
			tempString[0] = '-';
			tempString[1] = '\0';
			*spriteTextString = *spriteTextString + tempString;
		}
		//cout << "*spriteTextString=" << *spriteTextString << endl;

#else

		/*Generic Attack Related Sprite Information*/
	//tempString[0] = '\n';
	//tempString[1] = '\0';
	//*spriteTextString = *spriteTextString + tempString;
	*spriteTextString = *spriteTextString + '\n';
	//*spriteTextString = *spriteTextString + '\n';		//this triggers error bad
	//*spriteTextString = *spriteTextString + '\n';		//this triggers error very bad

	#ifdef SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
		*spriteTextString = *spriteTextString + "A = ";
	#endif
		if((unitDetailsInSceneFile->closeCombatAttackTotal > 0) || (unitDetailsInSceneFile->longDistanceAttackTotal > 0))
		{
			if((unitDetailsInSceneFile->closeCombatAttackValue) > (unitDetailsInSceneFile->longDistanceAttackValue))
			{
			#ifdef SPRITE_ALWAYS_ADD_TEXT
				tempString[0] = '\0';
				//itoa(baseCloseCombatAttackLevel, tempString, 10);
				sprintf(tempString, "%d", baseCloseCombatAttackLevel);
				*spriteTextString = *spriteTextString + tempString;
				if(unitDetailsInSceneFile->closeCombatAttackBonus > 0)
				{
					tempString[0] = '\0';
					//itoa(unitDetailsInSceneFile->closeCombatAttackBonus, tempString, 10);
					sprintf(tempString, "%d", unitDetailsInSceneFile->closeCombatAttackBonus);
					*spriteTextString = *spriteTextString + " + " + tempString;
				}
			#endif
			#ifdef SPRITES_DISPLAY_DICE
				if((unitDetailsInSceneFile->closeCombatAttackTotal >= MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED) && (unitDetailsInSceneFile->closeCombatAttackTotal <= MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED))
				{
					tempString[0] = (unitDetailsInSceneFile->closeCombatAttackTotal + SPRITE_CHARACTER_DICE_OFFSET);
					tempString[1] = '\0';
					*spriteTextString = *spriteTextString + tempString;
				}
				else
				{
				#ifndef SPRITE_ALWAYS_ADD_TEXT
					tempString[0] = '\0';
					//itoa(((unitDetailsInSceneFile->closeCombatAttackTotal)*2), tempString, 10);
					sprintf(tempString, "%d", (unitDetailsInSceneFile->closeCombatAttackTotal)*2);
					*spriteTextString = *spriteTextString + tempString;
				#endif
				}
			#endif
			}
			else
			{
			#ifdef SPRITE_ALWAYS_ADD_TEXT
				tempString[0] = '\0';
				//itoa(baseLongDistanceAttackLevel, tempString, 10);
				sprintf(tempString, "%d", baseLongDistanceAttackLevel);
				*spriteTextString = *spriteTextString + tempString;
				if(unitDetailsInSceneFile->longDistanceAttackBonus > 0)
				{
					tempString[0] = '\0';
					//itoa(unitDetailsInSceneFile->longDistanceAttackBonus, tempString, 10);
					sprintf(tempString, "%d", unitDetailsInSceneFile->longDistanceAttackBonus);
					*spriteTextString = *spriteTextString + " - " + tempString;
				}
			#endif
			#ifdef SPRITES_DISPLAY_DICE
				if((unitDetailsInSceneFile->longDistanceAttackTotal >= MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED) && (unitDetailsInSceneFile->longDistanceAttackTotal <= MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED))
				{
					//cout << "DEBUG 1i2" << endl;
					tempString[0] = (unitDetailsInSceneFile->longDistanceAttackTotal + SPRITE_CHARACTER_DICE_OFFSET);
					tempString[1] = '\0';
					//cout << "DEBUG 1i3" << endl;
					*spriteTextString = *spriteTextString + tempString;
				}
				else
				{
				#ifndef SPRITE_ALWAYS_ADD_TEXT
					tempString[0] = '\0';
					//itoa(((unitDetailsInSceneFile->longDistanceAttackTotal)*2), tempString, 10);
					sprintf(tempString, "%d", (unitDetailsInSceneFile->longDistanceAttackTotal)*2);
					*spriteTextString = *spriteTextString + tempString;
				#endif
				}
			#endif
			}
		}
		else
		{
			tempString[0] = '-';
			tempString[1] = '\0';
			*spriteTextString = *spriteTextString + tempString;
		}
		//cout << "*spriteTextString=" << *spriteTextString << endl;

#endif

	//cout << "DEBUG 1k" << endl;

#ifdef SPRITE_TEXTUAL_INCLUDE_MOVEMENT
	/*Movement Related Sprite Information*/
	*spriteTextString = *spriteTextString + '\n';
	//*spriteTextString = *spriteTextString + '\n';
#ifdef SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
	*spriteTextString = *spriteTextString + "     M = ";
#endif
	if(unitDetailsInSceneFile->movementSpeed > 0)
	{
		tempString[0] = '\0';
		//itoa(unitDetailsInSceneFile->movementSpeed, tempString, 10);
		sprintf(tempString, "%d", unitDetailsInSceneFile->movementSpeed);
		*spriteTextString = *spriteTextString + tempString;

		if(unitDetailsInSceneFile->longDistanceAttackBonus > 0)
		{
			tempString[0] = '\0';
			//itoa(unitDetailsInSceneFile->longDistanceAttackBonus, tempString, 10);
			sprintf(tempString, "%d", unitDetailsInSceneFile->longDistanceAttackBonus);
			*spriteTextString = *spriteTextString + " + " + tempString;
		}
	}
	else
	{
		tempString[0] = '-';
		tempString[1] = '\0';
		*spriteTextString = *spriteTextString + tempString;
	}
#endif

	//cout << "DEBUG 1l" << endl;

	delete tempString;



	//cout << "DEBUG: *spriteTextString = \n" << *spriteTextString << "\n\n" << endl;
	/*End Start Sprite Text Creation*/
}




bool LRRCaddSpriteListByteArrayToSceneFileInefficient(char * sceneFileName, char * sceneFileNameWithSprites, char * spriteListByteArray, int spriteListByteArraySize, int spriteListByteArrayLines)
{
	bool result = true;

	char * spriteHeaderSearchString = LRRC_SPRITE_HEADER_NAME;
	char * spriteTrailerSearchString = LRRC_SPRITE_TRAILER_NAME;
	int spriteHeaderSearchStringLength = LRRC_SPRITE_HEADER_LENGTH;
	int spriteTrailerSearchStringLength = LRRC_SPRITE_TRAILER_LENGTH;

	int sceneFileNumberOfLines;
	int sceneFileByteArraySize = 0;
	char * sceneFileByteArray = new char[DAT_FILE_MAX_NUM_OF_REFERENCES*DAT_FILE_REF_MAX_SIZE];

	if(!readFileIntoByteArray(sceneFileName, sceneFileByteArray, &sceneFileNumberOfLines, &sceneFileByteArraySize))
	{
		cout << "error: cannot read file, " << sceneFileName << endl;
		result = false;
	}
	else
	{
		int sceneFileNumberOfLinesWithSprites = sceneFileNumberOfLines;

		//TEMP DEBUG
		/*
		int temp1 = DAT_FILE_MAX_NUM_OF_REFERENCES;
		int temp2 = DAT_FILE_REF_MAX_SIZE;
		cout << "DAT_FILE_MAX_NUM_OF_REFERENCES = " << temp1 << endl;
		cout << "DAT_FILE_REF_MAX_SIZE = " << temp2 << endl;
		*/

		#ifdef TEMPDEBUG
		cout << "DEBUG; sceneFileByteArray = \n" << endl;
		for(int i = 0; i < sceneFileByteArraySize; i++)
		{
			cout << sceneFileByteArray[i];
		}
		cout << "DEBUG; sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
		cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
		#endif

		/*Start Sprite Header Section Confirmation*/

		int lineNumberOfSpriteHeader;
		int lineNumberOfSpriteTrailer;
		int lineNumberInFileOfSprite;

		bool spriteHeaderFound = false;
		bool spriteTrailerFound = false;

		/*determines whether a Sprite Header line exists in the scene file by looking for a spriteHeaderSearchString*/
		if(findTextInByteArray(sceneFileByteArray, sceneFileByteArraySize, spriteHeaderSearchString, spriteHeaderSearchStringLength, &lineNumberOfSpriteHeader))
		{
			spriteHeaderFound = true;
		}

		/*determines whether a Sprite Trailer line exists in the scene file by looking for a spriteHeaderSearchString*/
		if(findTextInByteArray(sceneFileByteArray, sceneFileByteArraySize, spriteTrailerSearchString, spriteTrailerSearchStringLength, &lineNumberOfSpriteTrailer))
		{
			spriteTrailerFound = true;
		}
		/*End Sprite Header Section Confirmation*/

		if(spriteHeaderFound && spriteTrailerFound)
		{
			/*sprite header info found, continue*/
			lineNumberInFileOfSprite = (lineNumberOfSpriteHeader+1);
			if(!replaceLinesInByteArray(sceneFileByteArray, spriteListByteArray, &sceneFileByteArraySize, spriteListByteArraySize, lineNumberInFileOfSprite, (lineNumberOfSpriteTrailer - lineNumberOfSpriteHeader - 1)))
			{
				cout << "ERROR0" << endl;
				cout << "error: cannot replace line in byte array" << endl;
				cout << "\t sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
				cout << "\t sceneFileByteArray = " << sceneFileByteArray << endl;
				cout << "\t spriteListByteArray = " << spriteListByteArray << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteListByteArraySize = " << spriteListByteArraySize << endl;
				cout << "\t lineNumberInFileOfSprite = " << lineNumberInFileOfSprite << endl;
				cout << "\t numLinesToReplace = " << (lineNumberOfSpriteTrailer - lineNumberOfSpriteHeader - 1) << endl;
				result = false;
			}

			//write the byteArray - replacing the original scene file
			writeByteArrayToFile(sceneFileNameWithSprites, sceneFileByteArray, sceneFileByteArraySize);
		}
		else if(!spriteHeaderFound && !spriteTrailerFound)
		{
			/*add a sprite header to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITE HEADER TO SCENE FILE \n\n" << endl;
			#endif

			lineNumberOfSpriteHeader = (sceneFileNumberOfLinesWithSprites-1);

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArraySize theoretical = " << (sceneFileByteArraySize + LRRC_SPRITE_HEADER_LENGTH) << endl;
			#endif

			if(!addLinesToByteArray(sceneFileByteArray, spriteHeaderSearchString, &sceneFileByteArraySize, spriteHeaderSearchStringLength, lineNumberOfSpriteHeader))
			{
				cout << "ERROR1" << endl;
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
				//cout << "\t sceneFileByteArray = " << sceneFileByteArray << endl;
				cout << "\t spriteHeaderSearchString = " << spriteHeaderSearchString << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteHeaderSearchStringLength = " << spriteHeaderSearchStringLength << endl;
				cout << "\t lineNumberOfSpriteHeader = " << lineNumberOfSpriteHeader << endl;
				result = false;
			}

			sceneFileNumberOfLinesWithSprites=sceneFileNumberOfLinesWithSprites+LRRC_SPRITE_HEADER_NUM_LINES;

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif

			/*add a sprites to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITES TO SCENE FILE  \n\n" << endl;
			#endif

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArraySize theoretical = " << (sceneFileByteArraySize + spriteListByteArraySize) << endl;
			#endif

			lineNumberInFileOfSprite = (sceneFileNumberOfLinesWithSprites-1);
			if(!addLinesToByteArray(sceneFileByteArray, spriteListByteArray, &sceneFileByteArraySize, spriteListByteArraySize, lineNumberInFileOfSprite))
			{
				cout << "ERROR2" << endl;
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
				//cout << "\t sceneFileByteArray = " << sceneFileByteArray << endl;
				cout << "\t spriteListByteArray = " << spriteListByteArray << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteListByteArraySize = " << spriteListByteArraySize << endl;
				cout << "\t lineNumberInFileOfSprite = " << lineNumberInFileOfSprite << endl;
				result = false;
			}

			sceneFileNumberOfLinesWithSprites = sceneFileNumberOfLinesWithSprites + spriteListByteArrayLines;


			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif


			/*add a sprite trailer to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITE TRAILER TO SCENE FILE  \n\n" << endl;
			#endif

			lineNumberOfSpriteTrailer = (sceneFileNumberOfLinesWithSprites-1);
			if(!addLinesToByteArray(sceneFileByteArray, spriteTrailerSearchString, &sceneFileByteArraySize, spriteTrailerSearchStringLength, lineNumberOfSpriteTrailer))
			{
				cout << "ERROR3" << endl;
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
				//cout << "\t sceneFileByteArray = " << sceneFileByteArray << endl;
				cout << "\t spriteTrailerSearchString = " << spriteTrailerSearchString << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteTrailerSearchStringLength = " << spriteTrailerSearchStringLength << endl;
				cout << "\t lineNumberOfSpriteTrailer = " << lineNumberOfSpriteTrailer << endl;
				cout << "\t sceneFileNameWithSprites = " << sceneFileNameWithSprites << endl;
				cout << "\t spriteListByteArrayLines = " << spriteListByteArrayLines << endl;
				cout << "\t sceneFileNumberOfLines = " << sceneFileNumberOfLines << endl;

				result = false;
			}
			sceneFileNumberOfLinesWithSprites=sceneFileNumberOfLinesWithSprites+LRRC_SPRITE_TRAILER_NUM_LINES;


			#ifdef TEMPDEBUG
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLinesWithSprites = " << sceneFileNumberOfLinesWithSprites << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif


			//write the byteArray - replacing the original scene file
			writeByteArrayToFile(sceneFileNameWithSprites, sceneFileByteArray, sceneFileByteArraySize);
		}
		else
		{
			result = false;
			cout << "error: file contains inconsistent sprite header/trailer, spriteHeaderFound = " << spriteHeaderFound << ", spriteTrailerFound = " << spriteTrailerFound << endl;
		}
	}

	delete sceneFileByteArray;

	return result;
}

/*this is not complete yet - just use an Identity matrix - ie do not rotate the sprite according to the user POV*/
void LRRCgenerateSpriteRotationMatrix(vec * spriteSceneCoords, vec * eyeCoords, mat * spriteRotationMatrix)
{
	//TEMP - this is not complete
	createIdentityMatrix(spriteRotationMatrix);		//CHECK THIS
}


void LRRCspriteSubmodelFillTextualReference(Reference * spriteSubmodelCurrentReference, vec * spriteParagraphCurrentPosition, char characterToWrite, int spriteColour)
{
	string referenceNameStart = SPRITE_CHARACTER_START;
	string referenceNameEnd = SPRITE_CHARACTER_EXTENSION;
	spriteSubmodelCurrentReference->colour = spriteColour;
	spriteSubmodelCurrentReference->type = REFERENCE_TYPE_SUBMODEL;

	spriteSubmodelCurrentReference->relativePosition.x = spriteParagraphCurrentPosition->x;
	spriteSubmodelCurrentReference->relativePosition.y = spriteParagraphCurrentPosition->y;
	spriteSubmodelCurrentReference->relativePosition.z = spriteParagraphCurrentPosition->z;

	mat currentDeformationMatrix;

	char * tempString = new char[SPRITE_INDEX_MAGNITUDE];

	if(((unsigned char)characterToWrite > (unsigned char)SPRITE_CHARACTER_DICE_OFFSET) && ((unsigned char)characterToWrite <= (unsigned char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL)))
	{
		/*no change to currentDeformationMatrix*/
		createIdentityMatrix(&currentDeformationMatrix);
			//double characterRotation = convertDegreesToRadian(SPRITE_TEXT_DICE_ROTATION_DEGREES);		//assume dice have already been appropriately rotated, and offset
			//createRotatationMatrix(currentDeformationMatrix, SPRITE_TEXT_DICE_ROTATION_AXIS, characterRotation);	//assume dice have already been appropriately rotated, and offset
		scaleMatrix(&currentDeformationMatrix, SPRITE_TEXT_DICE_SCALE_FACTOR);
		spriteSubmodelCurrentReference->relativePosition.y = spriteSubmodelCurrentReference->relativePosition.y + SPRITE_TEXT_DICE_Y_OFFSET;
		spriteSubmodelCurrentReference->colour = spriteSubmodelCurrentReference->colour + DAT_FILE_COLOUR_TRANPARENT_MOD;
		tempString[0] = 'd';
		int diceValue = ((unsigned char)characterToWrite - (unsigned char)SPRITE_CHARACTER_DICE_OFFSET)*2;
		if(diceValue > 9)
		{
			tempString[1] = 1 + SPRITE_CHARACTER_NUM_OFFSET;
			tempString[2] = (diceValue - 10) + SPRITE_CHARACTER_NUM_OFFSET;
			tempString[3] = '\0';
		}
		else
		{
			tempString[1] = (diceValue + SPRITE_CHARACTER_NUM_OFFSET);
			tempString[2] = '\0';
		}

	}
	else
	{
		createIdentityMatrix(&currentDeformationMatrix);
		scaleMatrix(&currentDeformationMatrix, SPRITE_TEXT_SCALE_FACTOR);
		tempString[0] = characterToWrite;
		tempString[1] = '\0';
	}

	copyMatrix2IntoMatrix1(&(spriteSubmodelCurrentReference->deformationMatrix), &(currentDeformationMatrix));
		//spriteSubmodelCurrentReference->deformationMatrix = currentDeformationMatrix;

	spriteSubmodelCurrentReference->name = referenceNameStart + tempString + referenceNameEnd;
	//cout << "DEBUG: spriteSubmodelCurrentReference->name = " << spriteSubmodelCurrentReference->name << endl;

	delete tempString;
}






